
_Main_Init:

;electronique_afficheur_score_001_16f628.mpas,43 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,44 :: 		CMCON := $07;     // disable comparators
	MOVLW      7
	MOVWF      CMCON+0
;electronique_afficheur_score_001_16f628.mpas,45 :: 		TRISA := %00100011;
	MOVLW      35
	MOVWF      TRISA+0
;electronique_afficheur_score_001_16f628.mpas,46 :: 		TRISB := %11111111;
	MOVLW      255
	MOVWF      TRISB+0
;electronique_afficheur_score_001_16f628.mpas,47 :: 		OPTION_REG := 0;
	CLRF       OPTION_REG+0
;electronique_afficheur_score_001_16f628.mpas,48 :: 		OPTION_REG.NOT_RBPU := 1;  // disable pullup
	BSF        OPTION_REG+0, 7
;electronique_afficheur_score_001_16f628.mpas,49 :: 		Ps2_Config;                // Init PS/2 Keyboard
	CALL       _Ps2_Config+0
;electronique_afficheur_score_001_16f628.mpas,50 :: 		Delay_ms(100);             // Wait for keyboard to finish init
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L__Main_Init1:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R12+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R11+0, 1
	GOTO       L__Main_Init1
	NOP
;electronique_afficheur_score_001_16f628.mpas,51 :: 		KeyPad_Init;
	CALL       _Keypad_Init+0
;electronique_afficheur_score_001_16f628.mpas,52 :: 		Delay_ms(100);             // Wait for keypad to finish init
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L__Main_Init2:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Init2
	DECFSZ     R12+0, 1
	GOTO       L__Main_Init2
	DECFSZ     R11+0, 1
	GOTO       L__Main_Init2
	NOP
;electronique_afficheur_score_001_16f628.mpas,53 :: 		end;
L_end_Main_Init:
	RETURN
; end of _Main_Init

_UserPrefs_Load:

;electronique_afficheur_score_001_16f628.mpas,58 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,59 :: 		iTmp := EEProm_Read($00);
	CLRF       FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      UserPrefs_Load_iTmp+0
;electronique_afficheur_score_001_16f628.mpas,60 :: 		bDispAutoRefresh := iTmp.0;
	MOVLW      0
	BTFSC      UserPrefs_Load_iTmp+0, 0
	MOVLW      1
	MOVWF      _bDispAutoRefresh+0
;electronique_afficheur_score_001_16f628.mpas,61 :: 		end;
L_end_UserPrefs_Load:
	RETURN
; end of _UserPrefs_Load

_UserPrefs_Save:

;electronique_afficheur_score_001_16f628.mpas,66 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,67 :: 		iTmp := $00;
	CLRF       UserPrefs_Save_iTmp+0
;electronique_afficheur_score_001_16f628.mpas,68 :: 		iTmp.0 := bDispAutoRefresh;
	BTFSC      _bDispAutoRefresh+0, 0
	GOTO       L__UserPrefs_Save153
	BCF        UserPrefs_Save_iTmp+0, 0
	GOTO       L__UserPrefs_Save154
L__UserPrefs_Save153:
	BSF        UserPrefs_Save_iTmp+0, 0
L__UserPrefs_Save154:
;electronique_afficheur_score_001_16f628.mpas,69 :: 		EEProm_Write($00, iTmp);
	CLRF       FARG_EEPROM_Write_address+0
	MOVF       UserPrefs_Save_iTmp+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_afficheur_score_001_16f628.mpas,70 :: 		end;
L_end_UserPrefs_Save:
	RETURN
; end of _UserPrefs_Save

_Disp_Mask:

;electronique_afficheur_score_001_16f628.mpas,73 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,75 :: 		0 : result  := %00111111;
	MOVF       FARG_Disp_Mask_iVal+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Mask9
	MOVLW      63
	MOVWF      R1+0
	GOTO       L__Disp_Mask6
L__Disp_Mask9:
;electronique_afficheur_score_001_16f628.mpas,76 :: 		1 : result  := %00000110;
	MOVF       FARG_Disp_Mask_iVal+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Mask12
	MOVLW      6
	MOVWF      R1+0
	GOTO       L__Disp_Mask6
L__Disp_Mask12:
;electronique_afficheur_score_001_16f628.mpas,77 :: 		2 : result  := %01011011;
	MOVF       FARG_Disp_Mask_iVal+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Mask15
	MOVLW      91
	MOVWF      R1+0
	GOTO       L__Disp_Mask6
L__Disp_Mask15:
;electronique_afficheur_score_001_16f628.mpas,78 :: 		3 : result  := %01001111;
	MOVF       FARG_Disp_Mask_iVal+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Mask18
	MOVLW      79
	MOVWF      R1+0
	GOTO       L__Disp_Mask6
L__Disp_Mask18:
;electronique_afficheur_score_001_16f628.mpas,79 :: 		4 : result  := %01100110;
	MOVF       FARG_Disp_Mask_iVal+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Mask21
	MOVLW      102
	MOVWF      R1+0
	GOTO       L__Disp_Mask6
L__Disp_Mask21:
;electronique_afficheur_score_001_16f628.mpas,80 :: 		5 : result  := %01101101;
	MOVF       FARG_Disp_Mask_iVal+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Mask24
	MOVLW      109
	MOVWF      R1+0
	GOTO       L__Disp_Mask6
L__Disp_Mask24:
;electronique_afficheur_score_001_16f628.mpas,81 :: 		6 : result  := %01111101;
	MOVF       FARG_Disp_Mask_iVal+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Mask27
	MOVLW      125
	MOVWF      R1+0
	GOTO       L__Disp_Mask6
L__Disp_Mask27:
;electronique_afficheur_score_001_16f628.mpas,82 :: 		7 : result  := %00000111;
	MOVF       FARG_Disp_Mask_iVal+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Mask30
	MOVLW      7
	MOVWF      R1+0
	GOTO       L__Disp_Mask6
L__Disp_Mask30:
;electronique_afficheur_score_001_16f628.mpas,83 :: 		8 : result  := %01111111;
	MOVF       FARG_Disp_Mask_iVal+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Mask33
	MOVLW      127
	MOVWF      R1+0
	GOTO       L__Disp_Mask6
L__Disp_Mask33:
;electronique_afficheur_score_001_16f628.mpas,84 :: 		9 : result  := %01101111
	MOVF       FARG_Disp_Mask_iVal+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Mask36
	MOVLW      111
	MOVWF      R1+0
;electronique_afficheur_score_001_16f628.mpas,85 :: 		else result := %01000000;
	GOTO       L__Disp_Mask6
L__Disp_Mask36:
	MOVLW      64
	MOVWF      R1+0
L__Disp_Mask6:
;electronique_afficheur_score_001_16f628.mpas,88 :: 		end;
	MOVF       R1+0, 0
	MOVWF      R0+0
L_end_Disp_Mask:
	RETURN
; end of _Disp_Mask

_Disp_Refresh:

;electronique_afficheur_score_001_16f628.mpas,94 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,96 :: 		Out_Data := 0;
	BCF        RA2_bit+0, 2
;electronique_afficheur_score_001_16f628.mpas,98 :: 		Out_Clock := 0;
	BCF        RA3_bit+0, 3
;electronique_afficheur_score_001_16f628.mpas,100 :: 		Out_Strobe := 0;
	BCF        RA4_bit+0, 4
;electronique_afficheur_score_001_16f628.mpas,102 :: 		for iDispIdx := 0 to 2 do
	CLRF       Disp_Refresh_iDispIdx+0
L__Disp_Refresh39:
;electronique_afficheur_score_001_16f628.mpas,106 :: 		0 : iDispVal := Disp_Mask(x0);
	MOVF       Disp_Refresh_iDispIdx+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Refresh46
	MOVF       _x0+0, 0
	MOVWF      FARG_Disp_Mask_iVal+0
	CALL       _Disp_Mask+0
	MOVF       R0+0, 0
	MOVWF      Disp_Refresh_iDispVal+0
	GOTO       L__Disp_Refresh43
L__Disp_Refresh46:
;electronique_afficheur_score_001_16f628.mpas,107 :: 		1 : iDispVal := Disp_Mask(x1);
	MOVF       Disp_Refresh_iDispIdx+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Refresh49
	MOVF       _x1+0, 0
	MOVWF      FARG_Disp_Mask_iVal+0
	CALL       _Disp_Mask+0
	MOVF       R0+0, 0
	MOVWF      Disp_Refresh_iDispVal+0
	GOTO       L__Disp_Refresh43
L__Disp_Refresh49:
;electronique_afficheur_score_001_16f628.mpas,108 :: 		2 : iDispVal := Disp_Mask(x2);
	MOVF       Disp_Refresh_iDispIdx+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__Disp_Refresh52
	MOVF       _x2+0, 0
	MOVWF      FARG_Disp_Mask_iVal+0
	CALL       _Disp_Mask+0
	MOVF       R0+0, 0
	MOVWF      Disp_Refresh_iDispVal+0
	GOTO       L__Disp_Refresh43
L__Disp_Refresh52:
L__Disp_Refresh43:
;electronique_afficheur_score_001_16f628.mpas,110 :: 		for iDispSeg := 7 downto 0 do
	MOVLW      7
	MOVWF      Disp_Refresh_iDispSeg+0
L__Disp_Refresh54:
;electronique_afficheur_score_001_16f628.mpas,112 :: 		Out_Data := iDispVal.iDispSeg;
	MOVF       Disp_Refresh_iDispSeg+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__Disp_Refresh157:
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Refresh158
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__Disp_Refresh157
L__Disp_Refresh158:
	MOVF       R0+0, 0
	ANDWF      Disp_Refresh_iDispVal+0, 0
	MOVWF      R2+0
	CLRF       R1+0
	MOVF       R2+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Refresh58
	MOVLW      1
	MOVWF      R1+0
L__Disp_Refresh58:
	BTFSC      R1+0, 0
	GOTO       L__Disp_Refresh159
	BCF        RA2_bit+0, 2
	GOTO       L__Disp_Refresh160
L__Disp_Refresh159:
	BSF        RA2_bit+0, 2
L__Disp_Refresh160:
;electronique_afficheur_score_001_16f628.mpas,113 :: 		Delay_us(iDelayData);
	MOVLW      33
	MOVWF      R13+0
L__Disp_Refresh59:
	DECFSZ     R13+0, 1
	GOTO       L__Disp_Refresh59
;electronique_afficheur_score_001_16f628.mpas,114 :: 		Out_Clock := 1;
	BSF        RA3_bit+0, 3
;electronique_afficheur_score_001_16f628.mpas,115 :: 		Delay_us(iDelayData);
	MOVLW      33
	MOVWF      R13+0
L__Disp_Refresh60:
	DECFSZ     R13+0, 1
	GOTO       L__Disp_Refresh60
;electronique_afficheur_score_001_16f628.mpas,116 :: 		Out_Clock := 0;
	BCF        RA3_bit+0, 3
;electronique_afficheur_score_001_16f628.mpas,117 :: 		Delay_us(iDelayData);
	MOVLW      33
	MOVWF      R13+0
L__Disp_Refresh61:
	DECFSZ     R13+0, 1
	GOTO       L__Disp_Refresh61
;electronique_afficheur_score_001_16f628.mpas,118 :: 		end;
	MOVF       Disp_Refresh_iDispSeg+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Refresh57
	DECF       Disp_Refresh_iDispSeg+0, 1
	GOTO       L__Disp_Refresh54
L__Disp_Refresh57:
;electronique_afficheur_score_001_16f628.mpas,119 :: 		end;
	MOVF       Disp_Refresh_iDispIdx+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_Refresh42
	INCF       Disp_Refresh_iDispIdx+0, 1
	GOTO       L__Disp_Refresh39
L__Disp_Refresh42:
;electronique_afficheur_score_001_16f628.mpas,121 :: 		Out_Strobe := 1;
	BSF        RA4_bit+0, 4
;electronique_afficheur_score_001_16f628.mpas,123 :: 		Out_Data := 0;
	BCF        RA2_bit+0, 2
;electronique_afficheur_score_001_16f628.mpas,124 :: 		Delay_us(iDelayData);
	MOVLW      33
	MOVWF      R13+0
L__Disp_Refresh62:
	DECFSZ     R13+0, 1
	GOTO       L__Disp_Refresh62
;electronique_afficheur_score_001_16f628.mpas,125 :: 		end;
L_end_Disp_Refresh:
	RETURN
; end of _Disp_Refresh

_Disp_SetLastValue:

;electronique_afficheur_score_001_16f628.mpas,128 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,129 :: 		x2 := x1;
	MOVF       _x1+0, 0
	MOVWF      _x2+0
;electronique_afficheur_score_001_16f628.mpas,130 :: 		x1 := x0;
	MOVF       _x0+0, 0
	MOVWF      _x1+0
;electronique_afficheur_score_001_16f628.mpas,131 :: 		x0 := iVal;
	MOVF       FARG_Disp_SetLastValue_iVal+0, 0
	MOVWF      _x0+0
;electronique_afficheur_score_001_16f628.mpas,132 :: 		if bDispAutoRefresh then
	MOVF       _bDispAutoRefresh+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Disp_SetLastValue65
;electronique_afficheur_score_001_16f628.mpas,133 :: 		Disp_Refresh;
	CALL       _Disp_Refresh+0
L__Disp_SetLastValue65:
;electronique_afficheur_score_001_16f628.mpas,134 :: 		end;
L_end_Disp_SetLastValue:
	RETURN
; end of _Disp_SetLastValue

_Disp_Reset:

;electronique_afficheur_score_001_16f628.mpas,137 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,138 :: 		x0 := 0;
	CLRF       _x0+0
;electronique_afficheur_score_001_16f628.mpas,139 :: 		x1 := 0;
	CLRF       _x1+0
;electronique_afficheur_score_001_16f628.mpas,140 :: 		x2 := 0;
	CLRF       _x2+0
;electronique_afficheur_score_001_16f628.mpas,141 :: 		Disp_Refresh;
	CALL       _Disp_Refresh+0
;electronique_afficheur_score_001_16f628.mpas,142 :: 		end;
L_end_Disp_Reset:
	RETURN
; end of _Disp_Reset

_Welcome:

;electronique_afficheur_score_001_16f628.mpas,145 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,146 :: 		for i := 0 to 9 do
	CLRF       _i+0
L__Welcome70:
;electronique_afficheur_score_001_16f628.mpas,148 :: 		x0 := i;
	MOVF       _i+0, 0
	MOVWF      _x0+0
;electronique_afficheur_score_001_16f628.mpas,149 :: 		x1 := i;
	MOVF       _i+0, 0
	MOVWF      _x1+0
;electronique_afficheur_score_001_16f628.mpas,150 :: 		x2 := i;
	MOVF       _i+0, 0
	MOVWF      _x2+0
;electronique_afficheur_score_001_16f628.mpas,151 :: 		Disp_Refresh;
	CALL       _Disp_Refresh+0
;electronique_afficheur_score_001_16f628.mpas,152 :: 		delay_ms(100);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L__Welcome74:
	DECFSZ     R13+0, 1
	GOTO       L__Welcome74
	DECFSZ     R12+0, 1
	GOTO       L__Welcome74
	DECFSZ     R11+0, 1
	GOTO       L__Welcome74
	NOP
;electronique_afficheur_score_001_16f628.mpas,153 :: 		end;
	MOVF       _i+0, 0
	XORLW      9
	BTFSC      STATUS+0, 2
	GOTO       L__Welcome73
	INCF       _i+0, 1
	GOTO       L__Welcome70
L__Welcome73:
;electronique_afficheur_score_001_16f628.mpas,154 :: 		end;
L_end_Welcome:
	RETURN
; end of _Welcome

_Keypad4x4_Read:

;electronique_afficheur_score_001_16f628.mpas,157 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,158 :: 		kp := Keypad_Key_Press;
	CALL       _Keypad_Key_Press+0
	MOVF       R0+0, 0
	MOVWF      _kp+0
;electronique_afficheur_score_001_16f628.mpas,159 :: 		if (kp > 0) then
	MOVF       R0+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L__Keypad4x4_Read77
;electronique_afficheur_score_001_16f628.mpas,161 :: 		if (not kpdown) then
	COMF       _kpdown+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L__Keypad4x4_Read80
;electronique_afficheur_score_001_16f628.mpas,164 :: 		1, 2, 3, 4, 5, 6, 7, 8, 9 : Disp_SetLastValue(kp);
	MOVF       _kp+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read85
	GOTO       L__Keypad4x4_Read83
L__Keypad4x4_Read85:
	MOVF       _kp+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read86
	GOTO       L__Keypad4x4_Read83
L__Keypad4x4_Read86:
	MOVF       _kp+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read87
	GOTO       L__Keypad4x4_Read83
L__Keypad4x4_Read87:
	MOVF       _kp+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read88
	GOTO       L__Keypad4x4_Read83
L__Keypad4x4_Read88:
	MOVF       _kp+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read89
	GOTO       L__Keypad4x4_Read83
L__Keypad4x4_Read89:
	MOVF       _kp+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read90
	GOTO       L__Keypad4x4_Read83
L__Keypad4x4_Read90:
	MOVF       _kp+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read91
	GOTO       L__Keypad4x4_Read83
L__Keypad4x4_Read91:
	MOVF       _kp+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read92
	GOTO       L__Keypad4x4_Read83
L__Keypad4x4_Read92:
	MOVF       _kp+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read93
L__Keypad4x4_Read83:
	MOVF       _kp+0, 0
	MOVWF      FARG_Disp_SetLastValue_iVal+0
	CALL       _Disp_SetLastValue+0
	GOTO       L__Keypad4x4_Read82
L__Keypad4x4_Read93:
;electronique_afficheur_score_001_16f628.mpas,165 :: 		10 : Disp_SetLastValue(0);
	MOVF       _kp+0, 0
	XORLW      10
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read96
	CLRF       FARG_Disp_SetLastValue_iVal+0
	CALL       _Disp_SetLastValue+0
	GOTO       L__Keypad4x4_Read82
L__Keypad4x4_Read96:
;electronique_afficheur_score_001_16f628.mpas,166 :: 		11 : Disp_Refresh;
	MOVF       _kp+0, 0
	XORLW      11
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read99
	CALL       _Disp_Refresh+0
	GOTO       L__Keypad4x4_Read82
L__Keypad4x4_Read99:
;electronique_afficheur_score_001_16f628.mpas,167 :: 		12 : Disp_Reset;
	MOVF       _kp+0, 0
	XORLW      12
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read102
	CALL       _Disp_Reset+0
	GOTO       L__Keypad4x4_Read82
L__Keypad4x4_Read102:
;electronique_afficheur_score_001_16f628.mpas,168 :: 		13 : begin
	MOVF       _kp+0, 0
	XORLW      13
	BTFSS      STATUS+0, 2
	GOTO       L__Keypad4x4_Read105
;electronique_afficheur_score_001_16f628.mpas,169 :: 		bDispAutoRefresh := not bDispAutoRefresh; // toggle value
	COMF       _bDispAutoRefresh+0, 1
;electronique_afficheur_score_001_16f628.mpas,170 :: 		UserPrefs_Save;
	CALL       _UserPrefs_Save+0
;electronique_afficheur_score_001_16f628.mpas,171 :: 		end;
	GOTO       L__Keypad4x4_Read82
L__Keypad4x4_Read105:
L__Keypad4x4_Read82:
;electronique_afficheur_score_001_16f628.mpas,173 :: 		kpdown := true;
	MOVLW      255
	MOVWF      _kpdown+0
;electronique_afficheur_score_001_16f628.mpas,174 :: 		end;
L__Keypad4x4_Read80:
;electronique_afficheur_score_001_16f628.mpas,175 :: 		end
	GOTO       L__Keypad4x4_Read78
;electronique_afficheur_score_001_16f628.mpas,176 :: 		else
L__Keypad4x4_Read77:
;electronique_afficheur_score_001_16f628.mpas,177 :: 		kpdown := false;
	CLRF       _kpdown+0
L__Keypad4x4_Read78:
;electronique_afficheur_score_001_16f628.mpas,178 :: 		end;
L_end_Keypad4x4_Read:
	RETURN
; end of _Keypad4x4_Read

_KeyboardPS2_Read:

;electronique_afficheur_score_001_16f628.mpas,181 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,183 :: 		if Ps2_Key_Read(iValue, iSpecial, iPressed) then
	MOVLW      _iValue+0
	MOVWF      FARG_Ps2_Key_Read_value+0
	MOVLW      _iSpecial+0
	MOVWF      FARG_Ps2_Key_Read_special+0
	MOVLW      _iPressed+0
	MOVWF      FARG_Ps2_Key_Read_pressed+0
	CALL       _Ps2_Key_Read+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read108
;electronique_afficheur_score_001_16f628.mpas,185 :: 		if (not kpdown) then
	COMF       _kpdown+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read111
;electronique_afficheur_score_001_16f628.mpas,188 :: 		if (iPressed > 0) and (iSpecial = 0) and (iValue > 0) then
	MOVF       _iPressed+0, 0
	SUBLW      0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _iSpecial+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVF       _iValue+0, 0
	SUBLW      0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read114
;electronique_afficheur_score_001_16f628.mpas,193 :: 		48,49,50,51,52,53,54,55,56,57 : Disp_SetLastValue(iValue - 48);
	MOVF       _iValue+0, 0
	XORLW      48
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read119
	GOTO       L__KeyboardPS2_Read117
L__KeyboardPS2_Read119:
	MOVF       _iValue+0, 0
	XORLW      49
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read120
	GOTO       L__KeyboardPS2_Read117
L__KeyboardPS2_Read120:
	MOVF       _iValue+0, 0
	XORLW      50
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read121
	GOTO       L__KeyboardPS2_Read117
L__KeyboardPS2_Read121:
	MOVF       _iValue+0, 0
	XORLW      51
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read122
	GOTO       L__KeyboardPS2_Read117
L__KeyboardPS2_Read122:
	MOVF       _iValue+0, 0
	XORLW      52
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read123
	GOTO       L__KeyboardPS2_Read117
L__KeyboardPS2_Read123:
	MOVF       _iValue+0, 0
	XORLW      53
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read124
	GOTO       L__KeyboardPS2_Read117
L__KeyboardPS2_Read124:
	MOVF       _iValue+0, 0
	XORLW      54
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read125
	GOTO       L__KeyboardPS2_Read117
L__KeyboardPS2_Read125:
	MOVF       _iValue+0, 0
	XORLW      55
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read126
	GOTO       L__KeyboardPS2_Read117
L__KeyboardPS2_Read126:
	MOVF       _iValue+0, 0
	XORLW      56
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read127
	GOTO       L__KeyboardPS2_Read117
L__KeyboardPS2_Read127:
	MOVF       _iValue+0, 0
	XORLW      57
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read128
L__KeyboardPS2_Read117:
	MOVLW      48
	SUBWF      _iValue+0, 0
	MOVWF      FARG_Disp_SetLastValue_iVal+0
	CALL       _Disp_SetLastValue+0
	GOTO       L__KeyboardPS2_Read116
L__KeyboardPS2_Read128:
L__KeyboardPS2_Read116:
;electronique_afficheur_score_001_16f628.mpas,195 :: 		end
	GOTO       L__KeyboardPS2_Read115
;electronique_afficheur_score_001_16f628.mpas,197 :: 		else if (iPressed > 0) and (iSpecial = 1) and (iValue = 13) then
L__KeyboardPS2_Read114:
	MOVF       _iPressed+0, 0
	SUBLW      0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _iSpecial+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVF       _iValue+0, 0
	XORLW      13
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read130
;electronique_afficheur_score_001_16f628.mpas,201 :: 		cKeyENTER : Disp_Refresh;
	MOVF       _iValue+0, 0
	XORLW      13
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read135
	CALL       _Disp_Refresh+0
	GOTO       L__KeyboardPS2_Read132
L__KeyboardPS2_Read135:
;electronique_afficheur_score_001_16f628.mpas,203 :: 		cKeyDELETE, cKeyESCAPE : Disp_Reset;
	MOVF       _iValue+0, 0
	XORLW      18
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read138
	GOTO       L__KeyboardPS2_Read136
L__KeyboardPS2_Read138:
	MOVF       _iValue+0, 0
	XORLW      34
	BTFSS      STATUS+0, 2
	GOTO       L__KeyboardPS2_Read139
L__KeyboardPS2_Read136:
	CALL       _Disp_Reset+0
	GOTO       L__KeyboardPS2_Read132
L__KeyboardPS2_Read139:
L__KeyboardPS2_Read132:
;electronique_afficheur_score_001_16f628.mpas,205 :: 		end;
L__KeyboardPS2_Read130:
L__KeyboardPS2_Read115:
;electronique_afficheur_score_001_16f628.mpas,206 :: 		end;
L__KeyboardPS2_Read111:
;electronique_afficheur_score_001_16f628.mpas,207 :: 		kpdown := true;
	MOVLW      255
	MOVWF      _kpdown+0
;electronique_afficheur_score_001_16f628.mpas,208 :: 		end
	GOTO       L__KeyboardPS2_Read109
;electronique_afficheur_score_001_16f628.mpas,209 :: 		else
L__KeyboardPS2_Read108:
;electronique_afficheur_score_001_16f628.mpas,210 :: 		kpdown := false;
	CLRF       _kpdown+0
L__KeyboardPS2_Read109:
;electronique_afficheur_score_001_16f628.mpas,211 :: 		end;
L_end_KeyboardPS2_Read:
	RETURN
; end of _KeyboardPS2_Read

_main:

;electronique_afficheur_score_001_16f628.mpas,213 :: 		begin
;electronique_afficheur_score_001_16f628.mpas,214 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_afficheur_score_001_16f628.mpas,215 :: 		Welcome;
	CALL       _Welcome+0
;electronique_afficheur_score_001_16f628.mpas,216 :: 		Disp_Reset;    // "000" value
	CALL       _Disp_Reset+0
;electronique_afficheur_score_001_16f628.mpas,217 :: 		Disp_Refresh;
	CALL       _Disp_Refresh+0
;electronique_afficheur_score_001_16f628.mpas,218 :: 		UserPrefs_Load;
	CALL       _UserPrefs_Load+0
;electronique_afficheur_score_001_16f628.mpas,219 :: 		while true do
L__main142:
;electronique_afficheur_score_001_16f628.mpas,221 :: 		if In_Mode then
	BTFSS      RA5_bit+0, 5
	GOTO       L__main147
;electronique_afficheur_score_001_16f628.mpas,223 :: 		Keypad4x4_Read
	CALL       _Keypad4x4_Read+0
	GOTO       L__main148
;electronique_afficheur_score_001_16f628.mpas,224 :: 		else
L__main147:
;electronique_afficheur_score_001_16f628.mpas,226 :: 		KeyboardPS2_Read;
	CALL       _KeyboardPS2_Read+0
L__main148:
;electronique_afficheur_score_001_16f628.mpas,227 :: 		Delay_ms(100);  // Debounce
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L__main149:
	DECFSZ     R13+0, 1
	GOTO       L__main149
	DECFSZ     R12+0, 1
	GOTO       L__main149
	DECFSZ     R11+0, 1
	GOTO       L__main149
	NOP
;electronique_afficheur_score_001_16f628.mpas,228 :: 		end;
	GOTO       L__main142
;electronique_afficheur_score_001_16f628.mpas,229 :: 		end.
L_end_main:
	GOTO       $+0
; end of _main
